﻿from os import listdir
from os.path import splitext


nomlist=[f for f in listdir(".") if splitext(f)[1]=='' and splitext(f)[0]!='supervisor']
feuille=5
#Comment utiliser ce fichier :
#- Python doit être installé sur votre ordinateur
#- sauvegarder la classe virtuelle, décompresser la sauvegarde et placer ce fichier dans le répertoire "score"
#- modifier ci-dessus le numéro de la feuille pour laquelle vous voulez visualiser l'activité des élèves
#- exécuter le fichier : un fichier html nommé "analyse-feuille.html" sera créé. Il ne reste plus qu'à l'éditer avec le logiciel de votre choix.

class LigneLog:
    #chaque ligne de log devient un objet
    def __init__(self,lineraw):
        #ligne raw designe la ligne "brute"
        lineraw=lineraw+'\t'
        lineraw=lineraw.split('\t')
        self.sc=True
        if(lineraw[2]=="noscore"):
            self.sc=False
        self.IP=lineraw[1]
        lineraw=lineraw[0].split(' ')
        dateraw=lineraw[0].split('.')
        self.date=dateraw[0]
        timeraw=dateraw[1].split(':')
        self.time=int(timeraw[0])*3600+int(timeraw[1])*60+int(timeraw[2])
        self.timetext=dateraw[1]
        self.session=lineraw[1]
        self.sheet=int(lineraw[2])
        self.exercise=int(lineraw[3])
        self.type=lineraw[4]
        self.score=0
        if(lineraw[4]=="score"):
            self.score=float(lineraw[5])

name="analyse-feuille "+str(feuille)+".html"
f=open(name, "a+b")
f.write("<html><head><title>Visualisation de  l'activit&eacute; des &eacute;l&egrave;ves sur la feuille "+str(feuille)+" :</title></head><body>")

for ii in range(len(nomlist)):
    nom=nomlist[ii]
    with open(nom, "r") as mon_fichier:
        contenu = mon_fichier.read()
    contenu=contenu.replace('  ',' ')
    contenu=contenu.split('\n')
    contenu.pop()#enl&egrave;ve le dernier &eacute;l&eacute;ment (une ligne vide)

    
    listelog=[" "," "," "," "," "," "," "," "," "," "," "," "," "," "," "]#va contenir les textes exo par exo
    listesession=[" "," "," "," "," "," "," "," "," "," "," "," "," "," "," "]#va contenir les num session exo par exo


    for line in range(len(contenu)):
        ligne=LigneLog(contenu[line])
        if line+1<len(contenu):
            ligne2=LigneLog(contenu[line+1])
            duree=ligne2.time-ligne.time
            if ligne2.date != ligne.date :
                duree=1000000
        if(ligne.sheet==feuille):
            exo=ligne.exercise
            if(exo>len(listelog)):
                print "Attention : exercices non pris en compte car la taille de listelog se limite à 13 exercices..."

            if str(ligne.session)!=str(listesession[exo-1]):
                listesession[exo-1]=ligne.session
                listelog[exo-1]+="<br />Le "+ligne.date[6:8]+"/"+ligne.date[4:6]+"/"+ligne.date[0:4]+" &agrave; partir de "+ligne.timetext+" : "

            font1="<font color='red'>"
            font2="</font>"
            if(ligne.sc):
                font1="<font color='green'><b>"
                font2="</b></font>"
            c=" &ndash;" #tiret court
            if duree<60:
                c=" &middot;" #point si recherche de moins d'une minute
            if duree>300:
                c=" &mdash;" #tiret long si recherche de plus de 5 minutes
            if(ligne.type=="score"):
                c=str(ligne.score)+" "
                c=c.replace(".0"," ")
            listelog[exo-1]+=font1+c+font2
    
    f.write("<p><b><u><i>Travail sur WIMS : </i></u></b> feuille n&deg;"+str(feuille)+"</p>")
    f.write("<p style='page-break-after:avoid'><b><u><i>Nom de login : </i></u></b> "+nom+"</p>")
    f.write("<p style='page-break-after:avoid'><b><u><i>L&eacute;gende : </i></u></b> Chaque tiret indique la visualisation d'un nouvel &eacute;nonc&eacute; (un tiret long indique une recherche de plus de 5 minutes et un point une recherche de moins d'une minute).<br />")
    f.write("Chaque nombre indique un score obtenu.<br />")
    f.write("La <font color='green'><b> couleur verte </b></font> indique que l'enregistrement des notes est activ&eacute;.<br />")
    f.write("La <font color='red'> couleur rouge </font> indique que l'enregistrement des notes est d&eacute;sactiv&eacute;. </p><p style='page-break-after:avoid'>")
    for i in range(14):
        if(listelog[i] != " "):
            f.write(" <b><u><i>Exercice n&deg;"+str(i+1)+" : </i></u></b>"+listelog[i]+"<br />")
    f.write("</p><p style='page-break-after:avoid'><b><u><i>Commentaires : </i></u></b><br /><br /><hr></p>")
f.write("</body></html>")
f.close
